package com.example.React_Native_back.board.service;

import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.util.UUID;

import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import com.example.React_Native_back.board.dto.ImageDTO;
import com.example.React_Native_back.board.repository.BoardDAO;

import lombok.RequiredArgsConstructor;

@Service
@RequiredArgsConstructor
public class FileService {
	private final BoardDAO boardDAO;

	private final String UPLOAD_DIR = "C:/Users/Moon/reactNative-workspace/React-Native-back/src/main/resources/static/images/";

    public int saveImage(MultipartFile file) throws IOException {
//        MultipartFile file = imageDTO.getFile();
        
        if (file == null || file.isEmpty()) {
            throw new IllegalArgumentException("File is missing.");
        }

        // 원본 파일 이름
        String originalName = file.getOriginalFilename();
    	System.out.println("originalName : "+originalName);
    	
    	// 중복이름 숫자 
    	int lastIndexOfDot = originalName.lastIndexOf(".");
        String name = originalName.substring(0, lastIndexOfDot);
        // 확장자
        String extension = originalName.substring(lastIndexOfDot);
        int fileNumber = 1;
        // 이름 중복 시 증가할 순번
        String fileSequence = "";
        while (new File(UPLOAD_DIR + name + fileSequence + extension).exists()) {
            fileSequence = "(" + fileNumber + ")";
            fileNumber++;
        }
        originalName = name + fileSequence + extension;
        UUID uuid = UUID.randomUUID();
        // 저장할 파일 이름 (UUID + 원본 확장자)
        String saveName = uuid + "_" + originalName;
    	System.out.println("saveName : "+saveName);

        // 파일 크기
    	
    	Long size = file.getSize();    	
//        System.out.println("size : "+size);
        
        String type= file.getContentType();    	
//        System.out.println("type : "+type);
        
        // 저장 경로 설정
        File saveFile = new File(UPLOAD_DIR, saveName);
//        System.out.println("saveFile : "+saveFile);
        if (!saveFile.exists()) {
            saveFile.mkdirs();
        }
        
        // 파일 저장
        file.transferTo(saveFile);

		//썸네일경로
		String thumbsname= UPLOAD_DIR+"\\"+uuid+"_thumbs_"+originalName;
		
		//썸네일 생성 (복사할파일위치,썸네일생성경로,가로,세로)
//		Thumbnailator.createThumbnail(new File(originalName),new File(thumbsname),150, 150);
		
        ImageDTO imageDTO = new ImageDTO();
        // DTO 정보 저장 (필요하면 DB 저장 로직 추가)
        imageDTO.setImageId(boardDAO.getImageId());
        imageDTO.setBoardImage(UPLOAD_DIR+saveName);
        imageDTO.setOriginalName(originalName);
        imageDTO.setSaveName(saveName);
        imageDTO.setSize(size);
        imageDTO.setFilePath(UPLOAD_DIR);
        imageDTO.setDeleteYn("N");
        System.out.println("service imageDTO ::"+imageDTO);
        return boardDAO.saveImage(imageDTO);
    }
    
    public int getImageId() throws Exception{
    	return boardDAO.getImageId();
    }
}
